Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Ray.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Ray.cpp	(revision 444)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Ray.cpp	(revision 448)
@@ -225,11 +225,13 @@
 mType(LOCAL_RAY)
 {
-	const float dist = Distance(vssRay.mTermination, vssRay.mOrigin);
-
-	if (dist)
-		dir = vssRay.GetDir() / dist;
+	float len = vssRay.Length();
+
+	if (!len)
+		len = Limits::Small;
+
+	dir = vssRay.GetDir() / len;
 
 	if (vssRay.mTerminationObject)
-		intersections.push_back(Intersection(dist, vssRay.mTerminationObject, 0));
+		intersections.push_back(Intersection(len, vssRay.mTerminationObject, 0));
 
 	Precompute();
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h	(revision 446)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h	(revision 448)
@@ -19,4 +19,6 @@
 class ViewCell;
 class BspTree;
+class VspBspTree;
+class BspNode;
 
 class X3dExporter : public Exporter
@@ -92,4 +94,12 @@
   ExportGeometry(const ObjectContainer &objects);
 
+  bool
+  ExportRays(const RayContainer &rays,
+			 const float length=1000,
+			 const RgbColor &color = RgbColor(1,1,1));
+  bool
+  ExportRays(const VssRayContainer &rays,
+			 const RgbColor &color = RgbColor(1,1,1));
+
   virtual void 
   ExportBspSplitPlanes(const BspTree &tree);
@@ -101,13 +111,4 @@
   ExportLeavesGeometry(const BspTree &tree, const vector<BspLeaf *> &leaves);
 
-  bool
-  ExportRays(const RayContainer &rays,
-						 const float length=1000,
-						 const RgbColor &color = RgbColor(1,1,1));
-
-	bool
-	ExportRays(const VssRayContainer &rays,
-						 const RgbColor &color = RgbColor(1,1,1));
-		
   virtual void
   ExportBspViewCellPartition(const BspTree &tree, const int maxPvs = 0);
@@ -116,5 +117,13 @@
   ExportBspLeaves(const BspTree &tree, const int maxPvs = 0);
 
+
+  virtual void 
+  ExportBspSplits(const VspBspTree &tree, const bool exportDepth);
+
+  virtual void
+  ExportBspViewCellPartition(const VspBspTree &tree, const int maxPvs = 0);
+
 protected:
+
 
   virtual void
@@ -126,9 +135,13 @@
   bool
   ExportBspTreeRayDensity(const BspTree &tree);
+  
+  void
+  AddBoxToMesh(const AxisAlignedBox3 &box,
+			   Mesh *mesh);
 
-	void
-	AddBoxToMesh(const AxisAlignedBox3 &box,
-							 Mesh *mesh);
-		
+  void ExportBspNodeSplits(BspNode *root,
+						   const AxisAlignedBox3 &box, 
+						   const bool exportDepth,
+						   const bool epsilon);
 };
  
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h	(revision 446)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h	(revision 448)
@@ -135,4 +135,6 @@
   Vector3 GetNormalizedDir() const { return (mTermination - mOrigin)*mInvSize; }
 
+  float Length() const { return Distance(mOrigin, mTermination); }
+
   Vector3 Extrap(const float t) const {
 	return GetOrigin() + t * GetDir();
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp	(revision 447)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp	(revision 448)
@@ -9,5 +9,5 @@
 #include "VssRay.h"
 #include "RssTree.h"
-
+#include "ViewCellBsp.h"
 
 static bool useViewSpaceBox = true;//true;
@@ -474,21 +474,4 @@
   }
   
-  //-- construct BSP view cells
-  if (ViewCell::sHierarchy == ViewCell::BSP) 
-  {
-	const int bspSamples = min((int)mVssRays.size(), mBspConstructionSamples);
-	
-	Debug << "bpssamples: " << bspSamples << endl;
-	for (int i = 0; i < bspSamples; ++ i)
-	  bspRays.push_back(new Ray(*mVssRays[i]));
-	
-	//-- construct BSP tree using the samples
-	mBspTree = new BspTree(&mUnbounded);	
-	
-	ObjectContainer objects;
-	mSceneGraph->CollectObjects(&objects);
-	mBspTree->Construct(objects, bspRays);
-  }
-  
   rssTree = new RssTree;
   // viewcells = Construct(mVssRays);
@@ -567,13 +550,4 @@
 	}
 
-	// cast rays into BSP tree
-	if (ViewCell::sHierarchy == ViewCell::BSP) 
-	  {
-		for (int i = 0; i < (int)vssRays.size(); ++ i)
-		  {
-			CastRay(*mBspTree, *vssRays[i]);
-		  }
-	  }
-
 	samples+=num;
 	float pvs = rssTree->GetAvgPvsSize();
@@ -598,19 +572,4 @@
   delete rssTree;
   
-  if (ViewCell::sHierarchy == ViewCell::BSP) 
-	{
-	  Debug << mBspTree->GetStatistics();
-
-	  ObjectContainer objects;
-	  ExportSplits(objects, bspRays, 10000);
-	  ExportBspPvs(objects, bspRays, 10000);
-
-	  BspViewCellsStatistics stat;
-	  mBspTree->EvaluateViewCellsStats(stat);
-	  Debug << "original view cell partition:\n" << stat << endl;
-
-	  // clear BSP samples
-	  CLEAR_CONTAINER(bspRays);
-	}
 
   return true;
@@ -646,7 +605,7 @@
 	  BspLeaf *leaf = ray.bspIntersections[j].mLeaf;
 	  // if ray not in unbounded space
-	  if (leaf->GetViewCell() != &mUnbounded)
+/*	  if (leaf->GetViewCell() != &mUnbounded)
 		contributingSamples += 
-		  leaf->GetViewCell()->GetPvs().AddSample(obj);
+		  leaf->GetViewCell()->GetPvs().AddSample(obj);*/
 	}
  
@@ -657,7 +616,7 @@
 		BspLeaf *leaf = ray.bspIntersections[j].mLeaf;
 		
-		if (leaf->GetViewCell() != &mUnbounded)
+	/*	if (leaf->GetViewCell() != &mUnbounded)
 		  leaf->GetViewCell()->
-			AddPassingRay(ray, contributingSamples ? 1 : 0);
+			AddPassingRay(ray, contributingSamples ? 1 : 0);*/
 	  }
   
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp	(revision 446)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp	(revision 448)
@@ -384,6 +384,4 @@
   VssTree *vssTree = NULL;
 
-  RayContainer bspRays;
-
   while (totalSamples < mInitialSamples) {
 	int passContributingSamples = 0;
@@ -454,5 +452,6 @@
   mSceneGraph->CollectObjects(&objects);
 
-  //mViewCellsManager->Construct(mVssRays, objects);
+  // construct view cells
+  mViewCellsManager->Construct(objects, mVssRays, mViewSpaceBox);
 
   vssTree = new VssTree;
@@ -489,4 +488,8 @@
   int samples = 0;
   int pass = 0;
+
+  /// Rays used for post processing and visualizations.
+  RayContainer storedRays;
+  // cast view cell samples
   while (1) {
 	int num = mVssSamplesPerPass;
@@ -503,6 +506,5 @@
 	  num = GenerateImportanceRays(vssTree, num, rays);
 	}
-		
-		
+			
 	for (int i=0; i < rays.size(); i++)
 	  CastRay(rays[i].mOrigin, rays[i].mDirection, vssRays);
@@ -528,13 +530,34 @@
 	}
 
-	// cast rays into BSP tree
-	/*if (ViewCell::sHierarchy == ViewCell::BSP) 
-	  {
-		for (int i = 0; i < (int)vssRays.size(); ++ i)
-		  {
-			CastRay(*mBspTree, *vssRays[i]);
-		  }
-	  }
-*/
+	//-- prepare traversal rays for view cell intersections
+	RayContainer passRays;
+
+	VssRayContainer::const_iterator it, it_end = vssRays.end();
+	
+	for (it = vssRays.begin(); it != it_end; ++ it)
+		passRays.push_back(new Ray(*(*it)));
+	
+	int sampleContributions = 0;
+	int contributingSamples = 0;
+
+	/// compute view cell contribution of rays
+	mViewCellsManager->ComputeSampleContributions(passRays,
+												  sampleContributions, 
+												  contributingSamples);
+	
+	//-- save rays for post processing
+	if (((int)storedRays.size() < mViewCellsManager->GetPostProcessSamples()) ||
+		((int)storedRays.size() < mViewCellsManager->GetVisualizationSamples()))
+	{
+		RayContainer::const_iterator it, it_end = passRays.end();
+
+		for (it = passRays.begin(); it != it_end; ++ it)
+			storedRays.push_back(new Ray(*(*it)));
+	}
+	else
+	{
+		CLEAR_CONTAINER(passRays);
+	}
+
 	samples+=num;
 	float pvs = vssTree->GetAvgPvsSize();
@@ -547,5 +570,11 @@
 	pass++;
   }
-	
+
+  //-- post process view cells
+  mViewCellsManager->PostProcess(objects, storedRays);
+  mViewCellsManager->Visualize(objects, storedRays);
+
+  CLEAR_CONTAINER(storedRays);
+
   delete vssTree;
 
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp	(revision 446)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp	(revision 448)
@@ -58,7 +58,4 @@
 	p->KdTreeStatistics(cout);
 	
-	// parse view cell hierarchy options
-	p->ParseViewCellsOptions();
-  
 	// parse view cells related options
 	p->PrepareViewCells();
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/RayInfo.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/RayInfo.cpp	(revision 437)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/RayInfo.cpp	(revision 448)
@@ -45,15 +45,15 @@
 float RayInfo::ExtrapOrigin(const int axis) const 
 {
-	return mRay->GetOrigin(axis) + GetMinT()*mRay->GetDir(axis);
+	return mRay->GetOrigin(axis) + GetMinT() * mRay->GetDir(axis);
 }
 		
 float RayInfo::ExtrapTermination(const int axis) const 
 {
-	return mRay->GetOrigin(axis) + GetMaxT()*mRay->GetDir(axis);
+	return mRay->GetOrigin(axis) + GetMaxT() * mRay->GetDir(axis);
 }
 
 Vector3 RayInfo::ExtrapOrigin() const 
 {
-	return mRay->GetOrigin() * mRay->GetDir();
+	return mRay->GetOrigin() + GetMinT() * mRay->GetDir();
 }
 		
@@ -134,4 +134,6 @@
 	t = splitPlane.FindT(mRay->GetOrigin(), mRay->GetTermination());
 
+//	Debug << "t: " << t << " mint " << GetMinT() << " maxt " << GetMaxT() << " orig: " << mRay->GetOrigin() <<
+//		" term " << mRay->GetTermination() << endl;
 	if ((t < GetMinT()) || (t > GetMaxT()))
 		return splitPlane.Side(ExtrapOrigin());
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp	(revision 436)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp	(revision 448)
@@ -42,9 +42,10 @@
 void Polygon3::Split(const Plane3 &partition, 
 					 Polygon3 &front, 
-					 Polygon3 &back)
+					 Polygon3 &back,
+					 const float epsilon)
 {
 	Vector3 ptA = mVertices.back();
 	
-	int sideA = partition.Side(ptA, Vector3::sDistTolerance);
+	int sideA = partition.Side(ptA, epsilon);
 	
 	VertexContainer::const_iterator it;
@@ -53,9 +54,10 @@
 
 	bool foundSplit = false;
-	// find line - plane intersections
+
+	//-- find line - plane intersections
 	for (it = mVertices.begin(); it != mVertices.end(); ++ it)
 	{
 		Vector3 ptB = *it;
-		int sideB = partition.Side(ptB, Vector3::sDistTolerance);
+		int sideB = partition.Side(ptB, epsilon);
 	
 		// vertices on different sides => split
@@ -68,6 +70,5 @@
 			
 				// test if split point not too close to previous split point
-				if (!foundSplit || 
-					(SqrDistance(splitPt, lastSplit) > Vector3::sDistToleranceSqrt))
+				if (!foundSplit || (!EpsilonEqualV3(splitPt, lastSplit, epsilon)))
 				{
 					// add vertex to both polygons
@@ -89,6 +90,5 @@
 				// test if split point not too close to other split point
 					// test if split point not too close to previous split point
-				if (!foundSplit || 
-					(SqrDistance(splitPt, lastSplit) > Vector3::sDistToleranceSqrt))
+				if (!foundSplit || (!EpsilonEqualV3(splitPt, lastSplit, epsilon)))
 				{
 					// add vertex to both polygons
@@ -125,7 +125,8 @@
 }
 
-int Polygon3::Side(const Plane3 &plane) const
-{
-	int classification = ClassifyPlane(plane);
+int Polygon3::Side(const Plane3 &plane, 
+				   const float epsilon) const
+{
+	int classification = ClassifyPlane(plane, epsilon);
 	
 	if (classification == BACK_SIDE)
@@ -137,5 +138,6 @@
 }
 
-int Polygon3::ClassifyPlane(const Plane3 &plane, const float tolerance) const
+int Polygon3::ClassifyPlane(const Plane3 &plane, 
+							const float epsilon) const
 {
 	VertexContainer::const_iterator it;
@@ -148,5 +150,5 @@
 	for (it = mVertices.begin(); it != mVertices.end(); ++ it)
 	{
-		const int side = plane.Side(*it, tolerance);
+		const int side = plane.Side(*it, epsilon);
 		
 		if (side > 0)
@@ -179,8 +181,8 @@
 }
 
-int Polygon3::ClassifyPlane(const Plane3 &plane) const
-{
-	return ClassifyPlane(plane, Vector3::sDistTolerance);
-}
+/*int Polygon3::ClassifyPlane(const Plane3 &plane) const
+{
+	return ClassifyPlane(plane, Limits::Small);
+}*/
 
 
@@ -207,5 +209,5 @@
 }
 
-bool Polygon3::Valid() const
+bool Polygon3::Valid(const float epsilon) const
 {
 	if (mVertices.size() < 3)
@@ -225,7 +227,7 @@
 	for (it = mVertices.begin(); it != it_end; ++it)
 	{
-		if (!(SqrDistance(vtx, *it) > sDistToleranceSqrt))
-		{
-			Debug << "Malformed vertices:\n" << *this << endl;
+		if (!(EpsilonEqual(vtx, *it)))
+		{
+			//Debug << "Malformed vertices:\n" << *this << endl;
 			return false;
 		}
@@ -385,5 +387,7 @@
 }
 
-int Polygon3::ClassifyPlane(const PolygonContainer &polys, const Plane3 &plane)
+int Polygon3::ClassifyPlane(const PolygonContainer &polys, 
+							const Plane3 &plane,
+							const float epsilon)
 {
 	PolygonContainer::const_iterator it;
@@ -395,5 +399,5 @@
 	for (it = polys.begin(); it != polys.end(); ++ it)
 	{
-        const int cf = (*it)->ClassifyPlane(plane);
+        const int cf = (*it)->ClassifyPlane(plane, epsilon);
 		
         if (cf == FRONT_SIDE)
@@ -445,5 +449,10 @@
 
 	for (pit = cell.begin(); pit != cell.end(); ++ pit)
+	{
+		if ((*pit)->mVertices.size() < 3)
+			Debug << "ERROR" << endl;
+
 		area += (*pit)->GetArea();
+	}
 
 	return area;
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 444)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 448)
@@ -75,7 +75,7 @@
 
 	mViewCellsManager->ComputeSampleContributions(rays, 
-												  castRaysToViewCells,
 												  sampleContributions, 
-												  contributingSamples);
+												  contributingSamples,
+												  castRaysToViewCells);
 }
 
@@ -397,6 +397,6 @@
 	//-- several visualizations and statistics
 		 
-	//-- render simulation
-	cout << "\nevaluating bsp view cells render time before merge ... ";
+	//-- render simulation after merge
+	cout << "\nevaluating bsp view cells render time after merge ... ";
 		 
 	const SimulationStatistics ss = mViewCellsManager->SimulateRendering();
@@ -405,5 +405,6 @@
 	cout << ss << endl;
 	Debug << ss << endl;
-		 
+	
+
 	mViewCellsManager->Visualize(objects, mSampleRays);	
     
@@ -424,5 +425,6 @@
 		RayContainer::const_iterator it, it_end = newRays.end();
 
-		if ((int)mVssSampleRays.size() < mViewCellsManager->GetConstructionSamples())
+		if ((int)mVssSampleRays.size() < 
+			mViewCellsManager->GetConstructionSamples())
 		{
 			for (it = newRays.begin(); it != it_end; ++ it)
@@ -433,14 +435,12 @@
 		else
 		{
-			// construct view cells using the collected samples
-			cout << "building view cells from " << (int)mVssSampleRays.size() << " samples " << endl;
-
+			// construct view cells
 			mViewCellsManager->Construct(objects, mVssSampleRays);
-			
+		
 			// throw away samples 
-			CLEAR_CONTAINER(mVssSampleRays);
-		}
-	}
-	// Need (ordered) rays for post processing => collect new rays
+			//CLEAR_CONTAINER(mVssSampleRays);
+		}
+	}
+	// Need rays (with ordered intersections) for post processing => collect new rays
 	else if (((int)mSampleRays.size() < mViewCellsManager->GetPostProcessSamples()) ||
 			 ((int)mSampleRays.size() < mViewCellsManager->GetVisualizationSamples()))
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp	(revision 372)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp	(revision 448)
@@ -1662,5 +1662,5 @@
 
 // TODO: use a table to avoid normal and distance computations
-Polygon3 *AxisAlignedBox3::CrossSection(const Plane3 &plane)
+Polygon3 *AxisAlignedBox3::CrossSection(const Plane3 &plane) const
 {
 	Polygon3 *planePoly = new Polygon3();
@@ -1746,2 +1746,27 @@
 	return planePoly;
 }
+
+bool AxisAlignedBox3::GetRaySegment(const Ray &ray, 
+									float &minT, 
+									float &maxT) const
+{
+	maxT = 1e6;
+	minT = 0;
+	
+	// test with  bounding box
+	if (!GetMinMaxT(ray, &minT, &maxT))
+		return false;
+
+	if (minT < 0) // start ray from origin
+		minT = 0;
+
+	// bound ray or line segment
+	if (//(ray.GetType() == Ray::LOCAL_RAY) && 
+	    !ray.intersections.empty() && 
+		(ray.intersections[0].mT <= maxT))
+	{
+		maxT = ray.intersections[0].mT;
+	}
+
+	return true;
+}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 444)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 448)
@@ -68,7 +68,7 @@
 
 void ViewCellsManager::ComputeSampleContributions(const RayContainer &rays, 
-												  const bool castRays,
 												  int &sampleContributions,
-												  int &contributingSamples)
+												  int &contributingSamples,
+												  const bool castRays)
 {
 	// view cells not yet constructed
@@ -168,5 +168,5 @@
 SimulationStatistics ViewCellsManager::SimulateRendering() const
 {
-	if (!ViewCellsConstructed())
+	if (!ViewCellsConstructed() || !mRenderSimulator)
 		return SimulationStatistics();
 
@@ -240,6 +240,4 @@
 		return 0;
 
-	Debug << "Constructing bsp view cells" << endl;
-
 	int sampleContributions = 0;
 	
@@ -247,4 +245,8 @@
 
 	int limit = min (mConstructionSamples, (int)rays.size());
+
+	// construct view cells using the collected samples
+	Debug << "construcing bsp view cells from " 
+		  << limit << " samples " << endl;
 
     for (int i = 0; i < limit; ++ i)
@@ -332,9 +334,9 @@
 	int pvsSize = 0;
 
-	BspViewCellsStatistics stat;
-	mBspTree->EvaluateViewCellsStats(stat);
-	Debug << "original view cell partition:\n" << stat << endl;
-		
-	if (1) // export view cells
+	BspViewCellsStatistics vcStats;
+	mBspTree->EvaluateViewCellsStats(vcStats);
+	Debug << "original view cell partition:\n" << vcStats << endl;
+		
+	if (1) // export view cells before merge
 	{
 		cout << "exporting initial view cells (=leaves) ... ";
@@ -344,5 +346,5 @@
 		{
 			exporter->SetWireframe();
-			exporter->ExportBspLeaves(*mBspTree, stat.maxPvs);
+			exporter->ExportBspLeaves(*mBspTree, vcStats.maxPvs);
 			//exporter->ExportBspViewCellPartition(*mBspTree, 0);
 				
@@ -360,10 +362,19 @@
 		}
 		cout << "finished" << endl;
-	}
+
+		//-- render simulation
+		cout << "\nevaluating bsp view cells render time before merge ... ";
+		 
+		const SimulationStatistics ss = SimulateRendering();
+			 
+		cout << " finished" << endl;
+		cout << ss << endl;
+		Debug << ss << endl;
+	}
+
 
 	cout << "starting post processing using " << mPostProcessSamples << " samples ... ";
-		
+
 	long startTime = GetTime();
-
 
 	//-- merge or subdivide view cells
@@ -408,4 +419,9 @@
 	cout << "merged " << merged << " view cells in "
 		 << TimeDiff(startTime, GetTime()) *1e-3 << " secs" << endl;
+
+	// statistics after post process
+	vcStats.Reset();
+	mBspTree->EvaluateViewCellsStats(vcStats);
+	Debug << "post processed view cell partition:\n" << vcStats << endl;
 
 	return merged;
@@ -956,5 +972,5 @@
 mVspKdTree(vspKdTree)
 {
-   mRenderSimulator = NULL; // TODO: new VspKdRenderSimulator(vspKdTree);
+   mRenderSimulator = NULL;//new VspKdRenderSimulator(vspKdTree);
    InitRenderSimulator();
 }
@@ -983,23 +999,9 @@
 		return 0;
 
-	//if (castRay) // TODO
+	//if (castRay)
+		//mVspKdTree->CastRay(ray);
 
 	int sampleContributions = 0;
 
-/*
-    for (int i = 0; i < (int)rays.size(); ++ i)
-	{
-		Ray *ray = rays[i];
-
-		mBspTree->CastRay(*ray);
-			
-		Intersectable *term = 
-			!ray->intersections.empty() ? ray->intersections[0].mObject : NULL
-			;
-		sampleContributions += 
-			AddSampleContributions(*ray, ray->sourceObject.mObject, term);
-			
-	}
-*/
 	return sampleContributions;
 }
@@ -1121,6 +1123,6 @@
 mVspBspTree(vspBspTree)
 {
-   mRenderSimulator = NULL;// TODO new VspBspRenderSimulator(bspTree);
-   //InitRenderSimulator();
+	mRenderSimulator = new VspBspRenderSimulator(vspBspTree);
+	InitRenderSimulator();
 }
 
@@ -1182,5 +1184,5 @@
 		for (int j = 0; j < (int)ray.bspIntersections.size(); ++ j)
 		{ 	
-			VspBspLeaf *leaf = NULL;  //TODO ray.bspIntersections[j].mLeaf;
+			BspLeaf *leaf = ray.bspIntersections[j].mLeaf;
 		
 			// if ray not in unbounded space
@@ -1206,5 +1208,5 @@
 		for (int j = 1; j < ((int)ray.bspIntersections.size() - 1); ++ j) 
 		{
-			VspBspLeaf *leaf = NULL;// TODO = ray.bspIntersections[j].mLeaf;
+			BspLeaf *leaf = ray.bspIntersections[j].mLeaf;
 
 			if (leaf->GetViewCell() != mVspBspTree->GetRootCell())
@@ -1219,5 +1221,4 @@
 										const RayContainer &rays)
 {
-	return 0;// TODO
 	if (!ViewCellsConstructed())
 	{
@@ -1231,5 +1232,5 @@
 	int pvsSize = 0;
 
-	VspBspViewCellsStatistics vcStats;
+	BspViewCellsStatistics vcStats;
 	mVspBspTree->EvaluateViewCellsStats(vcStats);
 	Debug << "original view cell partition:\n" << vcStats << endl;
@@ -1243,5 +1244,5 @@
 		{
 			exporter->SetWireframe();
-			//exporter->ExportBspLeaves(*mVspBspTree, stat.maxPvs);
+			exporter->ExportBspViewCellPartition(*mVspBspTree, vcStats.maxPvs);
 				
 			if (0)
@@ -1284,10 +1285,10 @@
 		iit = ray->bspIntersections.begin();
 
-		VspBspLeaf *previousLeaf = NULL;//TODO(*iit).mLeaf;
+		BspLeaf *previousLeaf = (*iit).mLeaf;
 		++ iit;
 		
 		for (; iit != ray->bspIntersections.end(); ++ iit)
 		{
-			VspBspLeaf *leaf = NULL;//TODO(*iit).mLeaf;
+			BspLeaf *leaf = (*iit).mLeaf;
 
 			if (ShouldMerge(leaf, previousLeaf))
@@ -1307,4 +1308,9 @@
 		 << TimeDiff(startTime, GetTime()) *1e-3 << " secs" << endl;
 
+	// statistics after post process
+	vcStats.Reset();
+	mVspBspTree->EvaluateViewCellsStats(vcStats);
+	Debug << "post processed view cell partition:\n" << vcStats << endl;
+
 	return merged;
 }
@@ -1319,10 +1325,9 @@
 									   const RayContainer &sampleRays)
 {
-	return; // TODO
 	if (!ViewCellsConstructed())
 		return;
 
 	//-- recount pvs
-	VspBspViewCellsStatistics vcStats;
+	BspViewCellsStatistics vcStats;
 	mVspBspTree->EvaluateViewCellsStats(vcStats);
 
@@ -1330,5 +1335,5 @@
 	{
 		cout << "exporting view cells after merge ... ";
-		/*Exporter *exporter = Exporter::GetExporter("merged_view_cells.x3d");
+		Exporter *exporter = Exporter::GetExporter("merged_view_cells.x3d");
 
 		if (exporter)
@@ -1337,5 +1342,5 @@
 			delete exporter;
 		}
-		*/
+		
 		cout << "finished" << endl;
 	}	
@@ -1343,5 +1348,5 @@
 	//-- visualization of the BSP splits
 	bool exportSplits = false;
-		environment->GetBoolValue("BspTree.Visualization.exportSplits", exportSplits);
+	environment->GetBoolValue("BspTree.Visualization.exportSplits", exportSplits);
 	
 	if (exportSplits)
@@ -1352,5 +1357,5 @@
 	}
 
-//TODO	ExportVspBspPvs(objects, sampleRays);
+	ExportBspPvs(objects, sampleRays);
 }
 
@@ -1367,6 +1372,6 @@
 		exporter->SetForcedMaterial(m);
 		exporter->SetWireframe();
-		// TODO
-		//exporter->ExportBspSplits(*mVspBspTree, true);
+		
+		exporter->ExportBspSplits(*mVspBspTree, true);
 
 		// take forced material, else big scenes cannot be viewed
@@ -1412,10 +1417,9 @@
 	const int raysOut = min((int)sampleRays.size(), mVisualizationSamples);
 	cout << "visualization using " << mVisualizationSamples << " samples" << endl;
-	vector<Ray *> vcRays[leafOut];
-
-	if (0)
+	
+	if (1)
 	{
 		//-- some random view cells and rays for output
-		vector<VspBspLeaf *> vspBspLeaves;
+		vector<BspLeaf *> vspBspLeaves;
 
 		for (int i = 0; i < leafOut; ++ i)
@@ -1424,7 +1428,8 @@
 		for (int i = 0; i < (int)vspBspLeaves.size(); ++ i)
 		{
+			RayContainer vcRays;
 			cout << "creating output for view cell " << i << " ... ";
 			// check whether we can add the current ray to the output rays
-			for (int k = 0; k < raysOut; ++ k) 
+			/*for (int k = 0; k < raysOut; ++ k) 
 			{
 				Ray *ray = sampleRays[k];
@@ -1436,8 +1441,9 @@
 					if (vspBspLeaves[i]->GetViewCell() == leaf->GetViewCell()) 
 					{
-						vcRays[i].push_back(ray);
+						vcRays.push_back(ray);
 					}
 				}
 			}
+			*/
 
 			Intersectable::NewMail();
@@ -1474,14 +1480,15 @@
 
 			Debug << i << ": pvs size=" << (int)vc->GetPvs().GetSize() 
-					<< ", piercing rays=" << (int)vcRays[i].size() << endl;
+					<< ", piercing rays=" << (int)vcRays.size() << endl;
 
 			// export rays piercing this view cell
-			exporter->ExportRays(vcRays[i], 1000, RgbColor(0, 1, 0));
-
-			m.mDiffuseColor = RgbColor(1, 0, 0);
+			exporter->ExportRays(vcRays, 1000, RgbColor(1, 0, 0));
+			exporter->ExportRays(vspBspLeaves[i]->mVssRays, RgbColor(1, 1, 1));
+			
+			m.mDiffuseColor = RgbColor(0, 1, 1);
 			exporter->SetForcedMaterial(m);
 
-			// exporter->SetWireframe();
-			exporter->SetFilled();
+			exporter->SetWireframe();
+			//exporter->SetFilled();
 
 			// output PVS of view cell
@@ -1527,5 +1534,5 @@
 		{
 			cout << "creating output for view cell " << i << " ... ";
-			
+			RayContainer vcRays;
             Intersectable::NewMail();
 			BspViewCell *vc = dynamic_cast<BspViewCell *>(viewCells[i]);
@@ -1539,9 +1546,9 @@
 				for	(int j = 0; j < (int)ray->bspIntersections.size(); ++ j)
 				{
-					VspBspLeaf *leaf = NULL; // TODO = ray->bspIntersections[j].mLeaf;
+					BspLeaf *leaf = ray->bspIntersections[j].mLeaf;
 
 					if (vc == leaf->GetViewCell()) 
 					{
-						vcRays[i].push_back(ray);
+						vcRays.push_back(ray);
 					}
 				}
@@ -1572,9 +1579,9 @@
 			
 			Debug << i << ": pvs size=" << (int)vc->GetPvs().GetSize() 
-					<< ", piercing rays=" << (int)vcRays[i].size() << endl;
+					<< ", piercing rays=" << (int)vcRays.size() << endl;
 
 			
 			// export rays piercing this view cell
-			exporter->ExportRays(vcRays[i], 1000, RgbColor(0, 1, 0));
+			exporter->ExportRays(vcRays, 1000, RgbColor(0, 1, 0));
 	
 			m.mDiffuseColor = RgbColor(1, 0, 0);
@@ -1607,6 +1614,6 @@
 
 
-bool VspBspViewCellsManager::MergeVspBspLeafViewCells(VspBspLeaf *front, 
-													  VspBspLeaf *back) const
+bool VspBspViewCellsManager::MergeVspBspLeafViewCells(BspLeaf *front, 
+													  BspLeaf *back) const
 {
 	BspViewCell *viewCell = 
@@ -1623,9 +1630,8 @@
 	BspViewCell *bVc = back->GetViewCell();
 
-	// TODO
-	/*vector<VspBspLeaf *> fLeaves = fVc->mBspLeaves;
-	vector<VspBspLeaf *> bLeaves = bVc->mBspLeaves;
-
-	vector<VspBspLeaf *>::const_iterator it;
+	vector<BspLeaf *> fLeaves = fVc->mBspLeaves;
+	vector<BspLeaf *> bLeaves = bVc->mBspLeaves;
+
+	vector<BspLeaf *>::const_iterator it;
 	
 	for (it = fLeaves.begin(); it != fLeaves.end(); ++ it)
@@ -1642,9 +1648,9 @@
 	DEL_PTR(fVc);
 	DEL_PTR(bVc);
-*/
+
 	return true;
 }
 
-bool VspBspViewCellsManager::ShouldMerge(VspBspLeaf *front, VspBspLeaf *back) const
+bool VspBspViewCellsManager::ShouldMerge(BspLeaf *front, BspLeaf *back) const
 {
 	ViewCell *fvc = front->GetViewCell();
